precision mediump float;

varying vec4 v_color;
varying vec2 v_texCoords;

uniform sampler2D u_texture;
uniform sampler2D screenBase;

uniform vec2 u_resolution;
uniform float u_offsetBy;

void main() {
  
  vec2 screenBaseSize=textureSize(screenBase, 0);
  vec2 usedScreenSize=(u_resolution.xy/screenBaseSize.xy);
  
  vec2 screenUV=gl_FragCoord.xy / u_resolution;
  
  screenUV.y = 1 - screenUV.y;
  screenUV.xy = screenUV.xy * usedScreenSize;
  
  vec2 spriteUV=v_texCoords;
  vec4 spriteColor = texture2D(u_texture, spriteUV);
  
  vec2 screenOffset=u_offsetBy*(spriteColor.xy-0.5)*spriteColor.a*v_color.a;
  
  //To allow some effect overlap if aren't using a dedicated post processing layer
  vec4 screenColor=(abs(screenOffset.x)<0.0002 && abs(screenOffset.y)<0.0002) ? vec4(0,0,0,0):vec4(1,1,1,1);
  //screenColor=vec4(1,1,1,1);
  
  screenUV.xy += screenOffset;
  
  screenUV.xy = min(screenUV.xy, usedScreenSize.xy);
  screenUV.xy = max(screenUV.xy, vec2(0,0));
  
  vec4 screenPixel = texture2D(screenBase, screenUV );
  
  gl_FragColor = screenPixel * screenColor;
  
}
